/* dynamic memory allocation using malloc() */

#include <stdio.h>
#include <stdlib.h>

int main() {
  int i, size;
  double *p;

  printf("How many values? ");
  scanf("%d", &size);

  p = (double *)malloc(size * sizeof(double));

  for (i=0; i<size; i++) {
    /* "p[i]" is the same as "*(p + i)" */
    /* if we use "i * i" we can run into problems for large values --
       it overflows the capacity of an int. */
    p[i] = ((double)i) * i;
  }

  for (i=0; i<size; i++) {
    printf("p[%d] = %f\n", i, p[i]);
  }

  return 0;
}
